module FoldMatTests where
import Mat; import MatExamples; import FoldMat; import Testing;
import MaxMatTests hiding (main); import ScaleMatTests hiding (main); import MapMatTests hiding (main)
main = dotests2 "FoldMatTests $Revision: 1.3 $" tests_mm (tests_sm ++ tests_mpm)
-- programming the examples using foldMat for testing purposes
maxMat = foldMat id maximum
scaleMat n = foldMat (\x -> S (n*x)) D
mapMat f = foldMat (\x -> S (f x)) D
-- parameterizing the tests to try out the above
tests_mm = maxMat_tests maxMat
tests_sm = scaleMat_tests scaleMat
tests_mpm = mapMat_tests mapMat
