-- $Id: MapMatTests.hs,v 1.1 2015/03/24 00:45:06 leavens Exp leavens $
module MapMatTests where
import Mat; import MatExamples; import MapMat; import Testing
main = dotests "MapMatTests $Revision: 1.1 $" (mapMat_tests mapMat)
mapMat_tests :: ((Int -> Int) -> (Mat Int) -> Mat Int) -> [TestCase (Mat Int)]
mapMat_tests mm = -- the argument mm is a solution to the problem
    [eqTest (mm (5+) (S 5)) "==" (S 10)
    ,eqTest (mm (10+) (ten2 (5,6))) "==" (fromRule2 (5,6) (\(i,j) -> 10+(10*i+j)))
    ,eqTest (mm (\n -> 2*(100+n)) (ht3 (7,8,9)))
                "==" (fromRule3 (7,8,9) (\(i,j,k) -> 2*(100+((100*i)+(10*j)+k))))
    ,eqTest (mm (+0) (ht3 (7,8,9))) "==" (ht3 (7,8,9))
    ,eqTest (mm (1+) (ht3 (5,6,7))) "==" (fromRule3 (5,6,7) (\(i,j,k) -> 1+(100*i)+(10*j)+k))
    ,eqTest (mm (3+) (unit3 (5,5,5))) "==" (fromRule3 (5,5,5)
                                         (\(i,j,k) -> if i==j&&j==k then 4 else 3))    ]
