-- $Id: MaxMatTests.hs,v 1.1 2015/03/23 00:03:47 leavens Exp $
module MaxMatTests where
import Mat; import MatExamples; import MaxMat; import Testing
main = dotests "MaxMatTests $Revision: 1.1 $" (maxMat_tests maxMat)
maxMat_tests :: (Mat Int -> Int) -> [TestCase Int]
maxMat_tests mm = -- the argument mm is a solution to the problem
    [eqTest (mm (S 5)) "==" 5
    ,eqTest (mm (ten2 (5,6))) "==" 56
    ,eqTest (mm (fromRule2 (100,300) (\(i,j) -> if i == 35 && j == 42 then 99999 else i-j))) "==" 99999
    ,eqTest (mm (ht3 (5,6,7))) "==" 567
    ,eqTest (mm (fromRule3 (10,20,30) (\(i,j,k) -> (40*i)-(30*j)-k))) "==" 369 ]
