-- $Id: ScaleMatTests.hs,v 1.1 2015/03/23 00:03:47 leavens Exp $
module ScaleMatTests where
import Mat; import MatExamples; import ScaleMat; import Testing
main = dotests "ScaleMatTests $Revision: 1.1 $" (scaleMat_tests scaleMat)
scaleMat_tests :: (Int -> (Mat Int -> Mat Int)) -> [TestCase (Mat Int)]
scaleMat_tests sm = -- the argument sm is a solution to the problem
    [eqTest (sm 5 (S 5)) "==" (S 25)
    ,eqTest (sm 10 (ten2 (5,6))) "==" (fromRule2 (5,6) (\(i,j) -> 10*(10*i+j)))
    ,eqTest (sm 100 (ht3 (7,8,9))) "==" (fromRule3 (7,8,9) (\(i,j,k) -> 100*((100*i)+(10*j)+k)))
    ,eqTest (sm 0 (ht3 (7,8,9))) "==" (zero3 (7,8,9))
    ,eqTest (sm 1 (ht3 (5,6,7))) "==" (ht3 (5,6,7))
    ,eqTest (sm 3 (unit3 (5,5,5))) "==" (fromRule3 (5,5,5)
                                         (\(i,j,k) -> if i==j&&j==k then 3 else 0))    ]
