-- $Id: FRMap2Tests.hs,v 1.1 2015/03/22 10:35:32 leavens Exp leavens $
module FRMap2Tests where
import FRMap2
import Testing
main = dotests "FRMap2Tests $Revision" tests_int
tests_int :: [TestCase [Integer]]
tests_int = 
    [eqTest (frMap2 fst []) "==" []
    ,eqTest (frMap2 fst [(-1,3),(-5,4)]) "==" [-1,-5]
    ,eqTest (frMap2 snd [(-1,3),(-5,4)]) "==" [3,4]
    ,eqTest (frMap2 (\(x,y) -> x+y) [(3,4),(5,6),(9,2)]) "==" [7,11,11]
    ,eqTest (frMap2 (\(x,y) -> x-y) [(3,4),(5,6),(9,2)]) "==" [-1,-1,7]
    ,eqTest (frMap2 (\(x,y) -> x*y) [(3,4),(5,6),(9,2)]) "==" [12,30,18]
    ,eqTest (frMap2 (\(x,y) -> 3*x+y-1) [(1,0),(0,0),(0,1),(2,3)])
     "==" [2,-1,0,8]
    ]
