-- $Id: SumLLTests.hs,v 1.1 2015/03/22 10:35:32 leavens Exp leavens $
module SumLLTests where
import SumLL
import Testing
main = dotests "SumLLTests $Revision" tests
tests :: [TestCase Integer]
tests = 
    [eqTest (sumLL []) "==" 0
    ,eqTest (sumLL [[]]) "==" 0
    ,eqTest (sumLL [[5,10]]) "==" 15
    ,eqTest (sumLL [[5],[10,20]]) "==" 35
    ,eqTest (sumLL [[1 .. 10],[100 .. 200]]) "==" 15205
    ,eqTest (sumLL [[1 .. 1000],[3],[4]]) "==" 500507
    ,eqTest (sumLL [[-55 .. 55],[-1,0,1],[-2000 .. 2000]]) "==" 0
    ,eqTest (sumLL [[-100 .. 99],[100,5]]) "==" 5
    ]
